type
  TArray = array[0..102] of extended;
var
  x, y: TArray;
  xn, yn: TArray;
  xa, ya: TArray;
  n: integer;
  d: integer;
  pos, neg: integer;
  vp, ax, ay, bx, by, ma, mb, cx, cy, mc: extended;
  cos2alpha, sinalpha, r: extended;
  cnt: integer;
  s1, s2: extended;
  i, j, k, tmp: integer;

  procedure myassert(c: boolean);
  begin
    if (not c) then
      halt(1);
  end;

  function vect_prod(x1, y1, x2, y2: extended): extended;
  begin
    Result := x1*y2 - x2*y1;
  end;

  function modulus(x, y: extended): extended;
  begin
    Result := sqrt(x*x + y*y);
  end;

  function area(var x, y: TArray; n: integer): extended;
  var
    s: extended;
  begin
    x[n+1] := x[1]; y[n+1] := y[1];
    s := 0;
    for i := 1 to n do
      s := s + vect_prod(x[i], y[i], x[i+1], y[i+1]);
    Result := abs(s)/2;
  end;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  myassert(not SeekEof(input));
  read(n);
  myassert((3 <= n) and (n <= 40));
  myassert(not SeekEof(input));
  read(d);
  myassert((1 <= d) and (d <= 100));
  for i := 1 to n do
  begin
    myassert(not SeekEof(input));
    //read(x[i]);
    read(tmp);
    x[i] := tmp;
    myassert(not SeekEof(input));
    //read(y[i]);
    read(tmp);
    y[i] := tmp;
    myassert((-100 <= x[i]) and (x[i] <= 100));
    myassert((0 <= y[i]) and (y[i] <= 100));
  end;
  myassert((y[1] = 0) and (y[n] = 0));
  myassert(SeekEof(input));

  //проверка выпуклости многоугольника
  x[n+1] := x[1]; y[n+1] := y[1];
  x[n+2] := x[2]; y[n+2] := y[2];
  pos := 0; neg := 0;
  for i := 1 to n do
  begin
    vp := vect_prod(x[i+1]-x[i], y[i+1]-y[i], x[i+2]-x[i+1], y[i+2]-y[i+1]);
    if (vp > 1e-6) then
      inc(pos)
    else if (vp < -1e-6) then
      inc(neg);
  end;
  //myassert((pos = n) or (neg = n));
  myassert(neg = n);

  //решение
  //находим подросший коготь...
  x[0] := x[n]; y[0] := y[n];
  for i := 1 to n do
  begin
    ax := x[i-1] - x[i]; ay := y[i-1] - y[i];
    bx := x[i+1] - x[i]; by := y[i+1] - y[i];
    ma := modulus(ax, ay);
    mb := modulus(bx, by);
    ax := ax/ma; ay := ay/ma;
    bx := bx/mb; by := by/mb;
    cx := -(ax + bx); cy := -(ay + by);
    mc := modulus(cx, cy);
    cx := cx/mc; cy := cy/mc;
    //{cx, cy} - единичный вектор, направленный
    //по биссектрисе во внешнюю область угла
    cos2alpha := ax*bx + ay*by;
    sinalpha := sqrt((1 - cos2alpha)/2);
    r := d/sinalpha;
    xn[i] := x[i] + cx*r; yn[i] := y[i] + cy*r;
  end;

  //обрезаем многоугольник осью абсцисс...
  i := 1;
  while (yn[i+1] < 0) do
  begin
    //пока отрезок [i, i+1] не пересекает ось абсцисс
    inc(i);
  end;
  j := n;
  while (yn[j-1] < 0) do
  begin
    //пока отрезок [j-1, j] не пересекает ось абсцисс
    dec(j);
  end;
  cnt := j-i+1;
  xa[1] := xn[i] - yn[i]*(xn[i+1]-xn[i])/(yn[i+1]-yn[i]);
  ya[1] := 0;
  xa[cnt] := xn[j] - yn[j]*(xn[j-1]-xn[j])/(yn[j-1]-yn[j]);
  ya[cnt] := 0;
  for k := 2 to cnt-1 do
  begin
    xa[k] := xn[i+k-1];
    ya[k] := yn[i+k-1];
  end;

  //вычисляем площади...
  s1 := area(x, y, n);
  s2 := area(xa, ya, cnt);

  write(s1:0:6, ' ', s2:0:6);

  close(input);
  close(output);
end.
