type
  TArray = array[0..101] of extended;
var
  x, y, xn, yn, xa, ya: TArray;
  n: integer;
  d: extended;
  a1, b1, c1, a2, b2, c2, cc1, cc2: extended;
  cnt: integer;
  s1, s2: extended;
  i, j, k: integer;

  procedure LineEquation(x1, y1, x2, y2: extended; var a, b, c: extended);
  begin
    a := y1 - y2;
    b := x2 - x1;
    c := x1*(y2 - y1) + y1*(x1 - x2);
  end;

  procedure ShiftLine(a, b, x0, y0: extended; var cc: extended);
  begin
    cc := -a*x0 - b*y0 - d*sqrt(a*a + b*b);
  end;

  function det(a11, a12, a21, a22: extended): extended;
  begin
    Result := a11*a22 - a12*a21;
  end;

  procedure IntersectLines(a1, b1, c1, a2, b2, c2: extended; var x, y: extended);
  var
    delta, deltax, deltay: extended;
  begin
    delta := det(a1, b1, a2, b2);
    deltax := det(-c1, b1, -c2, b2);
    deltay := det(a1, -c1, a2, -c2);
    x := deltax/delta;
    y := deltay/delta;
  end;

  function Area(var x, y: TArray; n: integer): extended;
  var
    s: extended;
  begin
    x[n+1] := x[1]; y[n+1] := y[1];
    s := 0;
    for i := 1 to n do
    begin
      s := s + (y[i] + y[i+1])*(x[i+1] - x[i]);
    end;
    Result := abs(s)/2;
  end;

begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  read(n, d);
  for i := 1 to n do
    read(x[i], y[i]);

  x[0] := x[n]; y[0] := y[n];
  x[n+1] := x[1]; y[n+1] := y[1];
  for i := 1 to n do
  begin
    LineEquation(x[i-1], y[i-1], x[i], y[i], a1, b1, c1);
    LineEquation(x[i], y[i], x[i+1], y[i+1], a2, b2, c2);
    ShiftLine(a1, b1, x[i], y[i], cc1);
    ShiftLine(a2, b2, x[i], y[i], cc2);
    IntersectLines(a1, b1, cc1, a2, b2, cc2, xn[i], yn[i]);
  end;

  i := 1;
  while (yn[i+1] < 0) do
    inc(i);
  j := n;
  while (yn[j-1] < 0) do
    dec(j);
  cnt := j-i+1;
  xa[1] := xn[i] - yn[i]*(xn[i+1]-xn[i])/(yn[i+1]-yn[i]);
  xa[cnt] := xn[j] - yn[j]*(xn[j-1]-xn[j])/(yn[j-1]-yn[j]);
  for k := 2 to cnt-1 do
  begin
    xa[k] := xn[i+k-1];
    ya[k] := yn[i+k-1];
  end;

  s1 := Area(x, y, n);
  s2 := Area(xa, ya, cnt);

  write(s1:0:6, ' ', s2:0:6);

  close(input);
  close(output);
end.
