unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls;

type

  { TfrmMain }

  TfrmMain = class(TForm)
    imgFigure: TImage;
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

  TArray = array[0..102] of extended;

var
  frmMain: TfrmMain;
  FigureSize: integer;
  x, y: TArray;
  xn, yn: TArray;
  xa, ya: TArray;
  n, cnt: integer;
  d: extended;
  minx, maxx, maxy: extended;

implementation

{$R *.lfm}

function modulus(x, y: extended): extended;
begin
  Result := sqrt(x*x + y*y);
end;

function min(a, b: extended): extended;
begin
  if (a < b) then
    Result := a
  else
    Result := b;
end;

procedure VisualPoint(x, y: extended; var vx, vy: integer);
var
  qq: extended;
begin
  qq := min(FigureSize/(maxx-minx), FigureSize/maxy);
  vx := round((x-minx)*qq) + 1;
  vy := FigureSize - round(y*qq) + 1;
end;

{ TfrmMain }

procedure TfrmMain.FormCreate(Sender: TObject);
var
  fin: TextFile;
  ax, ay, bx, by, ma, mb, cx, cy, mc: extended;
  cos2alpha, sinalpha, r: extended;
  ux, uy, vx, vy: integer;
  i, j, k: integer;
begin
  FigureSize := imgFigure.Width - 2;
  with imgFigure.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(0, 0, imgFigure.Width, imgFigure.Height);
    Pen.Width := 5;
    Line(0, FigureSize + 3, FigureSize, FigureSize + 3);
  end;

  AssignFile(fin, 'input.txt');
  Reset(fin);
  Read(fin, n, d);
  for i := 1 to n do
    read(fin, x[i], y[i]);
  CloseFile(fin);

  //находим подросший коготь...
  x[n+1] := x[1]; y[n+1] := y[1];
  x[n+2] := x[2]; y[n+2] := y[2];
  x[0] := x[n]; y[0] := y[n];
  for i := 1 to n do
  begin
    ax := x[i-1] - x[i]; ay := y[i-1] - y[i];
    bx := x[i+1] - x[i]; by := y[i+1] - y[i];
    ma := modulus(ax, ay);
    mb := modulus(bx, by);
    ax := ax/ma; ay := ay/ma;
    bx := bx/mb; by := by/mb;
    cx := -(ax + bx); cy := -(ay + by);
    mc := modulus(cx, cy);
    cx := cx/mc; cy := cy/mc;
    //{cx, cy} - единичный вектор, направленный
    //по биссектрисе во внешнюю область угла
    cos2alpha := ax*bx + ay*by;
    sinalpha := sqrt((1 - cos2alpha)/2);
    r := d/sinalpha;
    xn[i] := x[i] + cx*r; yn[i] := y[i] + cy*r;
  end;

  //обрезаем многоугольник осью абсцисс...
  i := 1;
  while (yn[i+1] < 0) do
  begin
    //пока отрезок [i, i+1] не пересекает ось абсцисс
    inc(i);
  end;
  j := n;
  while (yn[j-1] < 0) do
  begin
    //пока отрезок [j-1, j] не пересекает ось абсцисс
    dec(j);
  end;
  cnt := j-i+1;
  xa[1] := xn[i] - yn[i]*(xn[i+1]-xn[i])/(yn[i+1]-yn[i]);
  ya[1] := 0;
  xa[cnt] := xn[j] - yn[j]*(xn[j-1]-xn[j])/(yn[j-1]-yn[j]);
  ya[cnt] := 0;
  for k := 2 to cnt-1 do
  begin
    xa[k] := xn[i+k-1];
    ya[k] := yn[i+k-1];
  end;

  //визуализация...
  minx := MaxInt; maxx := -MaxInt; maxy := -MaxInt;
  for i := 1 to cnt do
  begin
    if (xa[i] < minx) then
      minx := xa[i];
    if (xa[i] > maxx) then
      maxx := xa[i];
    if (ya[i] > maxy) then
      maxy := ya[i];
  end;

  imgFigure.Canvas.Pen.Width := 3;
  for i := 1 to n-1 do
  begin
    VisualPoint(x[i], y[i], ux, uy);
    VisualPoint(x[i+1], y[i+1], vx, vy);
    imgFigure.Canvas.Line(ux, uy, vx, vy);
  end;
  imgFigure.Canvas.Pen.Width := 2;
  for i := 1 to cnt-1 do
  begin
    VisualPoint(xa[i], ya[i], ux, uy);
    VisualPoint(xa[i+1], ya[i+1], vx, vy);
    imgFigure.Canvas.Line(ux, uy, vx, vy);
  end;
end;

end.

